function [fitresult, gof,ft] = createFit(avgPulseTime, avgFilteredPulse)
%CREATEFIT(AVGPULSETIME,AVGFILTEREDPULSE)
%  Create a fit.
%
%  Data for 'FitFourier' fit:
%      X Input : avgPulseTime
%      Y Output: avgFilteredPulse
%  Output:
%      fitresult : a fit object representing the fit.
%      gof : structure with goodness-of fit info.
%
%  See also FIT, CFIT, SFIT.

%  Auto-generated by MATLAB on 18-Mar-2016 16:25:47


%% Fit: 'FitFourier'.
[xData, yData] = prepareCurveData( avgPulseTime, avgFilteredPulse );

% Set up fittype and options.
ft = fittype( 'fourier3' );
opts = fitoptions( 'Method', 'NonLinearLeastSquares' );
opts.Algorithm = 'Levenberg-Marquardt';
opts.Display = 'off';
opts.Normalize = 'on';
opts.StartPoint = [0 0 0 0 0 0 0  1.23038063925939];
opts.TolFun = 1e-12;
opts.TolX = 1e-12;

% Fit model to data.
[fmodel, gof] = fit( xData, yData, ft, opts );

%Save the avgPulseTime for adjusting the length later
fitresult=struct('fmodel',fmodel,'pulseTime',avgPulseTime);
% Plot fit with data.
% figure( 'Name', 'FitFourier' );
% h = plot( fitresult, xData, yData );
% legend( h, 'avgFilteredPulse vs. avgPulseTime', 'FitFourier', 'Location', 'NorthEast' );
% Label axes
% xlabel avgPulseTime
% ylabel avgFilteredPulse
% grid on


